using FluentValidation;
using CMSMicroservice.Protobuf.Protos.Contract;
namespace CMSMicroservice.Protobuf.Validator.Contract;

public class GetAllContractByFilterRequestValidator : AbstractValidator<GetAllContractByFilterRequest>
{
    public GetAllContractByFilterRequestValidator()
    {
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<GetAllContractByFilterRequest>.CreateWithOptions((GetAllContractByFilterRequest)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
